package hu.unideb.inf.shoppinglist;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {

    private TextView itemsList;
    private boolean isListEmpty=true;

    private static final String ITEMSLIST_TEXT_STATE_KEY = "hu.unideb.inf.LISTSTRING";
    private static final String EMPTZLIST_BOOL_STATE_KEY = "hu.unideb.inf.EMPTYLIST";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        itemsList = findViewById(R.id.listTextView);
        if (savedInstanceState!=null){
            itemsList.setText(savedInstanceState.getString(ITEMSLIST_TEXT_STATE_KEY));
            isListEmpty = savedInstanceState.getBoolean(EMPTZLIST_BOOL_STATE_KEY);
        }
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putString(ITEMSLIST_TEXT_STATE_KEY, itemsList.getText().toString());
        outState.putBoolean(EMPTZLIST_BOOL_STATE_KEY, isListEmpty);
    }

    public void handleButtonClicked(View view) {
        Intent intent = new Intent(this, ItemsListActivity.class);
        switch( ((Button)view).getText().toString() ){
            case "Add" :  startActivityForResult(intent, 1); break;
            case "Search" :  startActivityForResult(intent, 2); break;
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case 1:
                if (resultCode == RESULT_OK) {
                    if (isListEmpty) {
                        itemsList.setText("");
                        isListEmpty = false;
                    }
                    itemsList.append(data.getStringExtra(ItemsListActivity.INTENT_EXTRA_NAME_ITEM) + "\n");
                }break;
            case 2:
                if (resultCode == RESULT_OK) {
                    Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.google.com/search?q=" + data.getStringExtra(ItemsListActivity.INTENT_EXTRA_NAME_ITEM)));
                    if (intent.resolveActivity(getPackageManager()) != null){
                        startActivity(intent);
                    }
                }
        }
    }
}
